#!/bin/bash
#Uncomment next line to debug this script.
#set -x

################
# Check section#
################

# Only root can excute this script.
if [ $UID != 0 ]; then
	echo "You must be root to excute this program."
	exit 1
fi

# Show how to use
if [ $# -eq 0 ]; then
   echo "usage: Adduser datafile" >&2
   exit 1
fi

if [ $# -gt 1 ]; then
   echo "Error: Only one file at a time." >&2
   exit 1
fi

#######################
# Set variables       #
#######################
cat $1 | while read a
do
 user=`echo $a | cut -f4 -d" "`
 passwd=`echo $a | cut -f2 -d" "`
 name=`echo $a | awk '{print $1, $5, $3}'`
 grp="student"

################################
# Add users following the rule #
################################
 if /usr/sbin/useradd -m \
                      -c "$name" \
                      -g $grp \
                      -d /export/students/$user \
                      -s /bin/csh \
                      $user 2> /dev/null
 then
    echo "Added login '$user' to group '$grp'," \
         "created home dir '/home/students/$user'"
 else
    echo "Failed to add user - '$user'" >&2
    exit 1
 fi

################################
# Set user's password.
################################
 if ./adder $user $passwd > /dev/null
 then
    echo "Set login password of '$user' to '$passwd'"
 else
    echo "Failed to set password of '$user'." >&2
    exit 1
 fi

################################
# Set user's quota
################################
 if edquota -p default $user > /dev/null
 then
    echo "Set user's quota...Done"
 else
    echo "Failed to set quota of '$user'." >&2
    exit 1
 fi
done
